#! /bin/sh
# the next line restarts using wish8.0 \
exec wish "$0" "$@"
# interface generated by SpecTcl version 1.1 from /home/ajackson/bin/edit_setup.ui
#   root     is the parent window for this user interface
global base


proc edit_setup_ui {root args} {
	 global base

	# this treats "." as a special case

	if {$root == "."} {
	    set base ""
	} else {
	    set base $root
	}
    
	frame $base.frame#1

	label $base.label#1 \
		-text {Edit setup file}
	catch {
		$base.label#1 configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-160-*-*-*-*-*-*
	}

	listbox $base.setup \
		-height 0 \
		-width 0 \
		-yscrollcommand "$base.scrollbar#1 set"

	scrollbar $base.scrollbar#1 \
		-command "$base.setup yview" \
		-orient v

	button $base.add_us \
		-text {Add US City}\
		-command "add_us .add_us_d"

	button $base.add_non_us \
		-background Grey60 \
		-text {Add Non-US
 City}

	button $base.delete \
		-text Delete\
		-command delete_city

	button $base.done \
		-text Done\
		-command exit


	# Geometry management

	grid $base.frame#1 -in $root	-row 2 -column 1 
	grid $base.label#1 -in $root	-row 1 -column 2  \
		-columnspan 2 \
		-sticky w
	grid $base.setup -in $root	-row 2 -column 2  \
		-sticky nesw
	grid $base.scrollbar#1 -in $root	-row 2 -column 3  \
		-sticky ns
	grid $base.add_us -in $base.frame#1	-row 1 -column 1  \
		-sticky ew
	grid $base.add_non_us -in $base.frame#1	-row 2 -column 1 
	grid $base.delete -in $base.frame#1	-row 3 -column 1  \
		-sticky ew
	grid $base.done -in $base.frame#1	-row 4 -column 1  \
		-sticky ew

	# Resize behavior management

	grid rowconfigure $root 1 -weight 0 -minsize 30
	grid rowconfigure $root 2 -weight 1 -minsize 133
	grid columnconfigure $root 1 -weight 0 -minsize 30
	grid columnconfigure $root 2 -weight 0 -minsize 162
	grid columnconfigure $root 3 -weight 0 -minsize 30

	grid rowconfigure $base.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 2 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 3 -weight 0 -minsize 30
	grid rowconfigure $base.frame#1 4 -weight 0 -minsize 30
	grid columnconfigure $base.frame#1 1 -weight 0 -minsize 30
# additional interface code
# end additional interface code

}

proc readsetup {} {
	 global base setupfile
	 if { [$base.setup size] > 0} {
		  $base.setup delete 0 end
	 }
	 if {[file exists "~/.TkWeatherrc"] == 1} {
	 		set rcfile [open "~/.TkWeatherrc" r]
			while {[gets $rcfile line] >= 0} {
				 set foo [split $line {:}]
				 set setupfile([lindex $foo 3]) $line
				$base.setup insert end [lindex $foo 3]
			}
			close $rcfile
	 }
}

proc delete_city {} {
	 global base setupfile
	 if {[array size  setupfile] == 0} {return}
	 if {[selection own] == ""} {return}
	 puts [selection get]
	 unset setupfile([selection get]) ; # delete element
	 set rcfile [open "~/.TkWeatherrc" w]
	 set searchid [array startsearch setupfile]
	 while {[array anymore setupfile $searchid]} {
			puts $rcfile $setupfile([array nextelement setupfile $searchid])
	  }
	  array donesearch setupfile $searchid
	  close $rcfile
	 readsetup
}

#----------------------------------------------
proc add_us {w} {
	
catch {destroy $w}

# interface generated by SpecTcl version 1.1 from /home/ajackson/bin/getcity.ui
#   root     is the parent window for this user interface

global state_code city_code w_addus 
toplevel $w 
wm title $w "Select City"
set w_addus $w

proc getcity_ui {root args} {

	 global state_code city_code w_addus

    
	frame $w_addus.frame#1

	label $w_addus.label#1 \
		-text Select

	label $w_addus.state \
		-text State \
		-textvariable state
	catch {
		$w_addus.state configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-120-*-*-*-*-*-*
	}

	label $w_addus.city \
		-text City \
		-textvariable city

	listbox $w_addus.statelist \
		-height 0 \
		-width 0 \
		-exportselection true\
		-yscrollcommand "$w_addus.scrollbar#1 set"
	catch {
		$w_addus.statelist configure \
			-font -*-Helvetica-Bold-R-Normal-*-*-120-*-*-*-*-*-*
	}

	scrollbar $w_addus.scrollbar#1 \
		-command "$w_addus.statelist yview" \
		-orient v

	listbox $w_addus.citylist \
		-height 0 \
		-width 0 \
		-yscrollcommand "$w_addus.scrollbar#2 set"

	scrollbar $w_addus.scrollbar#2 \
		-command "$w_addus.citylist yview" \
		-orient v

	button $w_addus.okbutton \
		-text OK\
		-command "okay $root"

	button $w_addus.applybutton \
		-text Apply \
		-command apply 

	button $w_addus.cancelbutton \
		-text Cancel \
		-command "destroy $root"


	# Geometry management

	grid $w_addus.frame#1 -in $root	-row 2 -column 1 -sticky s
	grid $w_addus.label#1 -in $root	-row 1 -column 1 
	grid $w_addus.state -in $root	-row 1 -column 2 
	grid $w_addus.city -in $root	-row 1 -column 4 
	grid $w_addus.statelist -in $root	-row 2 -column 2  \
		-sticky nesw
	grid $w_addus.scrollbar#1 -in $root	-row 2 -column 3  \
		-sticky ns
	grid $w_addus.citylist -in $root	-row 2 -column 4  \
		-sticky nesw
	grid $w_addus.scrollbar#2 -in $root	-row 2 -column 5  \
		-sticky ns
	grid $w_addus.okbutton -in $w_addus.frame#1	-row 1 -column 1  \
		-sticky esw
	grid $w_addus.applybutton -in $w_addus.frame#1	-row 2 -column 1  \
		-sticky esw
	grid $w_addus.cancelbutton -in $w_addus.frame#1	-row 3 -column 1  \
		-sticky esw

	# Resize behavior management

	grid rowconfigure $root 1 -weight 0 -minsize 30
	grid rowconfigure $root 2 -weight 1 -minsize 67
	grid columnconfigure $root 1 -weight 0 -minsize 30
	grid columnconfigure $root 2 -weight 0 -minsize 96
	grid columnconfigure $root 3 -weight 0 -minsize 30
	grid columnconfigure $root 4 -weight 0 -minsize 112 
	grid columnconfigure $root 5 -weight 0 -minsize 22

	grid rowconfigure $w_addus.frame#1 1 -weight 0 -minsize 30
	grid rowconfigure $w_addus.frame#1 2 -weight 0 -minsize 2
	grid rowconfigure $w_addus.frame#1 3 -weight 0 -minsize 15
	grid columnconfigure $w_addus.frame#1 1 -weight 0 -minsize 30
# additional interface code


# end additional interface code

}

proc okay {w} {
	apply
	destroy $w
}

proc apply {} {
	 global base state_code statecd city_code
	  set rcfile [open "~/.TkWeatherrc" a]
	  puts $rcfile "uscity:$statecd:$city_code([selection get]):[selection get]"
	  close $rcfile
	  readsetup
	  
}

proc readstates {} {
	 global state_code w_addus
	 if {[file exists "~/bin/tkweatherlib/state_codes"] == 1} {
	 		set stfile [open "~/bin/tkweatherlib/state_codes" r]
			while {[gets $stfile line] >= 0} {
				 set foo [split $line {:}]
				 set state_code([lindex $foo 1]) [lindex $foo 0]; # code-name array
				$w_addus.statelist insert end [lindex $foo 1]
			}
			close $stfile
	 }
}

proc readcities {state} {
	 global state_code city_code w_addus statecd
	 set statecd $state_code($state)
	 if {[file exists "~/bin/tkweatherlib/$state_code($state)"] == 1} {
	 		set cyfile [open "~/bin/tkweatherlib/$state_code($state)" r]
		  $w_addus.citylist delete 0 end
			while {[gets $cyfile line] >= 0} {
				 set foo [split $line {:}]
				 set city_code([lindex $foo 1]) [lindex $foo 0]; # code-name array
				$w_addus.citylist insert end [lindex $foo 1]
			}
			close $cyfile
	 }
}

wm geometry $w 380x150
getcity_ui $w

readstates

bind $w_addus.statelist <ButtonRelease-1> {
	puts [selection get]
	readcities [selection get]
}
}
#----------------------------------------------

# Allow interface to be run "stand-alone" for testing

catch {
    if [info exists embed_args] {
	# we are running in the plugin
	edit_setup_ui .
    } else {
	# we are running in stand-alone mode
	if {$argv0 == [info script]} {
	    wm title . "Edit Setup File"
	    edit_setup_ui .
	}
    }
}

readsetup
