#!/usr/bin/wish -f
#	Simple Balloon Help Package by
#	Robin Becker	robin@jessikat.demon.co.uk
#	Stewart Inglis	singlis@lucy.cs.waikato.ac.nz Fri Apr  4 08:57:43 1997
#	This is version 0.1
#
#	Array indeces
#	a	appearances -1 for ever, 0 never, >0 a times
#	d	delay
#	k	kill delay
#	p,w	pending for widget w
#	a,w	appearances for widget w
#	k,w	auto kill time for widget w
#	m,w	the message for widget w
#	K,w	possible hanging kill after id
#	f	font
#	c	foreground
#	b	background

global _blnHlPrv tcl_platform
set _blnHlPrv(a) -1
set _blnHlPrv(k) 5000
set _blnHlPrv(d) 950
set _blnHlPrv(c) RoyalBlue
set _blnHlPrv(b) #fffffa9fbdb1

set DEBUG 0

if { $tcl_platform(platform) == "unix" } {
	set _blnHlPrv(f) -Adobe-Helvetica-Medium-R-Normal--*-80-*-*-*-*-*-*
	} \
elseif	{ $tcl_platform(platform) == "windows" } {
	set _blnHlPrv(f) -Adobe-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*
	}

proc balloonHelp {w m args} {
	global _blnHlPrv DEBUG
        if { $DEBUG } {
	    puts "balloonHelp $w $m $args"
        }
	foreach i {d a k} {
		set _blnHlPrv($i,$w) $_blnHlPrv($i)
		}
	foreach { i v } $args  {
		switch -glob -- $i \
			-d* { set _blnHlPrv(d,$w) $v } \
			-k* { set _blnHlPrv(k,$w) $v } \
			-a* { set _blnHlPrv(a,$w) $v } \
			default { error "bad args to balloonHelp" }
		}
	set _blnHlPrv(m,$w) "$m"
	set b [bind $w <Any-Enter>]
	if {![regexp "balloonHelp_show $w " $b]} {
		if {$b == ""} {
			set b [bind [winfo class $w] <Any-Enter>]
			}
		if {"$b"!=""} {
			set b "; $b"
			}
		bind $w <Any-Enter> "balloonHelp_show $w %W$b"
		}
	set b [bind $w <Any-Leave>]
	if {![regexp "balloonHelp_kill $w " $b]} {
		if {$b == ""} {
			set b [bind [winfo class $w] <Any-Leave>]
			}
		if {"$b"!=""} {
			set b "; $b"
			}
		bind $w <Any-Leave> "balloonHelp_kill $w 1 %W$b"
		}
}

proc balloonHelp_show {w W} {
	global _blnHlPrv DEBUG
	if { $DEBUG } {
		puts "balloonHelp_show $w $W"
		}
	if {"$w"=="$W"} {
		catch { after cancel $_blnHlPrv(K,$w);unset _blnHlPrv(K,$w) }
		catch { after cancel $_blnHlPrv(p,$w);unset _blnHlPrv(p,$w) }
		if {$_blnHlPrv(a,$w) != 0} {
			set d $_blnHlPrv(d,$w)
			if {[info exists _blnHlPrv(0)]} {
				set d 0
				set _blnHlPrv(p,$w) 0
				balloonHelp_show2 $w
				} \
			else {
				set _blnHlPrv(p,$w) [after $d "balloonHelp_show2 $w"]
				}
			set _blnHlPrv(K,$w) [after [expr $d + $_blnHlPrv(k,$w)] "balloonHelp_kill $w 0 $w"]
			}
		}
}

proc balloonHelp_show2 {w} {
	global _blnHlPrv DEBUG
        if { $DEBUG } {
 	    puts "balloonHelp_show2 $w"
        }
	if {![info exists _blnHlPrv(p,$w)]} return
	unset _blnHlPrv(p,$w)
	catch	{
		set x [winfo rootx $w]
		set Y [winfo rooty $w]
		set y [expr $Y + [winfo height $w] ]
		balloonHelp_root $w
		toplevel $r -relief ridge -borderwidth 2 
		wm overrideredirect $r 1
		wm geometry $r +${x}+${y}
		pack [message $r.m -bg $_blnHlPrv(b) -fg $_blnHlPrv(c) -text "$_blnHlPrv(m,$w)" -aspect 2000 -font $_blnHlPrv(f)]
		catch	{
			tkwait vis $r
			set a [winfo rooty $r]
			set b [winfo height $r]
			set g 0
			if { [expr $a+$b] > [winfo screenheight $w] } {
				set g 1
				set y [expr $Y-$b]
				}
			if { $x < 0 } {
				set g 1
				set x 0
				}
			if { $g == 1 } {
				wm geometry $r +${x}+${y}
				}
			balloonHelp_delay
			}
		if {$a>0} {
			incr _blnHlPrv(a,$w) -1
			}
		}
}

proc balloonHelp_delay {} {
	global _blnHlPrv DEBUG
    if { $DEBUG } {
		puts "balloonHelp_delay"
    	}
	catch { after cancel $_blnHlPrv(0);unset _blnHlPrv(0) }
}

proc balloonHelp_kill {w m W} {
	global _blnHlPrv DEBUG
	if { $DEBUG } {
		puts "balloonHelp_kill $w $m $W"
		}
	if {"$w"=="$W"} {
		catch { after cancel $_blnHlPrv(K,$w);unset _blnHlPrv(K,$w) }
		catch { after cancel $_blnHlPrv(p,$w);unset _blnHlPrv(p,$w) }
		balloonHelp_root $w
		balloonHelp_delay
		if {[winfo exists $r]} {
			catch {destroy $r}
			update idletasks
			if {$m} {
				set _blnHlPrv(0) [after 2000 balloonHelp_delay]
				}
			}
		}
}

proc balloonHelp_hide {w} {
	global _blnHlPrv DEBUG
	if { $DEBUG } {
		puts "balloonHelp_hide $w"
		}
	balloonHelp_root $w
	catch {unset _blnHlPrv(p,$w) }
	catch {wm withdraw $r; update idletasks; destroy $r; update idletasks}
}

proc balloonHelp_root { w } {
	if { "$w" == "." } { set w {} }
	uplevel 1 set r $w.balloon
}

package provide balloonHelp 0.1
